在命令:工作号码

时间:2015-07-13 18:48:46

标签: shell at-job

我正在编写一个bash脚本,我使用命令at

如何获取使用at创建的作业的编号? (如果需要,可以删除。)

该命令实际上不返回任何内容。当我在shell中使用at时,我从系统得到响应,但我无法捕获它。它不是来自命令本身。

3 个答案:

答案 0 :(得分:1)

我假设你在Unix / Linux系统上。这个答案在Solaris Unix机器上测试过。 Linux(Red Hat)类似,但是at job id格式是一个简单的短号。

在作业实际运行之前,没有生成PID,但at job id会返回 标准错误

> at -t 07141116 2> at out < commandfile
> cat at.out
job 1436868960.a at Tue Jul 14 11:16:00 2015

您可以使用at -l命令

检查其状态
> at -l
1436868960.a    Tue Jul 14 11:16:00 2015

答案 1 :(得分:0)

作业编号由at命令打印,但遗憾的是它打印到standard error,而不是打印到标准输出。因此,要捕获它,您需要将其重定向到标准输出。

以下代码段将at的输出捕获到变量中。我在C语言环境中运行at,因为它可能会在其他语言中生成不同的输出。如果命令失败,我打印出我捕获的错误消息。否则我解析输出以找到作业号。

at_output=$(printf %s "$command" | LANGUAGE= LC_ALL=C at "$time" 2>&1)
at_status=$?
if [ "$at_status" -ne 0 ]; then
  echo "at $time failed with status $at_status" >&2
  echo "$at_output"
  exit $at_status
fi
newline='
'
case "$at_output" in
  "job "*) at_job=${at_output#job };;
  *"${newline}job "*) at_job=${at_output#*"${newline}job "};;
  *) echo >&2 "$at_output"; echo >&2 "Unable to determine at job number!";;
esac
at_job=${at_job%% *}

答案 2 :(得分:-1)

It sounds like your shell has a syntax error (and therefore fails immediately). Does it run on the command line by itself? Do you define the path within the script?

If nothing else, put a statement in to echo out the id.

echo PS is $$ > logfile